package com.hkbu.mapviewoverlay;

import java.util.ArrayList;

import android.content.Context;
import android.graphics.Canvas;
import android.graphics.drawable.Drawable;
import android.widget.Toast;

import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.MapView;
import com.google.android.maps.OverlayItem;

public class MapItemizedOverlay extends ItemizedOverlay<OverlayItem> {
	
	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
	private Drawable marker = null;
	private Context context;
	
	public MapItemizedOverlay(Drawable defaultMarker, Context context) {
		super(defaultMarker);
		// TODO Auto-generated constructor stub
		this.marker = defaultMarker;
		this.context = context;
	}

	@Override
	protected OverlayItem createItem(int i) {
		// TODO Auto-generated method stub
		return mOverlays.get(i);
	}

	@Override
	public int size() {
		// TODO Auto-generated method stub
		return mOverlays.size();
	}
	
	@Override
	public void draw(Canvas canvas, MapView mapView, boolean shadow) {
		super.draw(canvas, mapView, shadow);
		boundCenterBottom(marker);
	}
	
	public void addOverlay(OverlayItem overlay) {
	    mOverlays.add(overlay);
	    populate();
	}
	
	@Override
    protected boolean onTap(int i){
		OverlayItem item = mOverlays.get(i);
		Toast.makeText(context, item.getTitle() + ", " + item.getSnippet(), Toast.LENGTH_SHORT).show();
        return(true);
    }
}
