package com.hkbu.mapviewoverlay;

import java.util.List;
import android.os.Bundle;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;

public class MapViewOverlayexampleActivity extends MapActivity {
	private MapView mapView;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        mapView = (MapView)findViewById(R.id.mapView);
        mapView.setBuiltInZoomControls(true);
        mapView.getController().setZoom(10);
        
        List<Overlay> mapOverlays = mapView.getOverlays();
        
        MapItemizedOverlay itemizedoverlay = new MapItemizedOverlay(getResources().getDrawable(R.drawable.marker), getApplicationContext());
        itemizedoverlay.addOverlay(new OverlayItem(new GeoPoint((int)(22.340399*1E6),(int)(114.179609*1E6)), "HKBU", "Ho Sin Hang Campus"));
        itemizedoverlay.addOverlay(new OverlayItem(new GeoPoint((int)(22.33875*1E6),(int)(114.18206*1E6)), "HKBU", "Baptist University Road Campus"));
        mapOverlays.add(itemizedoverlay);
        
        mapView.getController().animateTo(new GeoPoint((int)(22.340399*1E6),(int)(114.179609*1E6)));
    }

	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
}