package com.hkbu.parsexml;

import java.net.URL;
import java.net.URLConnection;
import java.util.ArrayList;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;
import org.w3c.dom.Element;

import android.app.Activity;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

public class ParseXMLexampleActivity extends Activity {
	private HashMap<String, String> map;
	private ArrayList<HashMap<String, String>> bookList;
	
	private TextView resultTv;
	private Button parseXMLBtn;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        resultTv = (TextView)findViewById(R.id.result);
        parseXMLBtn = (Button)findViewById(R.id.parseXML);
        parseXMLBtn.setOnClickListener(parseXMLBtnListener);
        bookList = new ArrayList<HashMap<String, String>>();
    }
    
    private OnClickListener parseXMLBtnListener = new OnClickListener(){
		@Override
		public void onClick(View arg0) {
			// TODO Auto-generated method stub
			loadXML();
			showResult();
			bookList.clear();
		}
    };
    
    private void loadXML(){
    	try {
			URL url = new URL("http://www.comp.hkbu.edu.hk/~sigis/android/public/books.xml");
			
			URLConnection urlConn = url.openConnection();
			urlConn.setConnectTimeout(10000);
			urlConn.connect();
			
	    	DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
	    	DocumentBuilder db;
			db = dbf.newDocumentBuilder();
			Document doc = db.parse(new InputSource(url.openStream()));
			doc.getDocumentElement().normalize();
			NodeList nodeList = doc.getElementsByTagName("book");
			
			for (int i = 0; i < nodeList.getLength(); i++) {
				Node node = nodeList.item(i);

				map = new HashMap<String, String>();
				
				Element fstElmnt = (Element) node;
				NodeList list;
				Element element;
											
				list = fstElmnt.getElementsByTagName("name");
				element = (Element) list.item(0);
				list = element.getChildNodes();
				if(list.getLength()>0){
					map.put("name", ((Node)list.item(0)).getNodeValue());
				}else{
					map.put("name", "");
				}
				map.put("isbn", element.getAttribute("isbn"));
				
				
				list = fstElmnt.getElementsByTagName("author");
				element = (Element) list.item(0);
				list = element.getChildNodes();
				if(list.getLength()>0){
					map.put("author", ((Node)list.item(0)).getNodeValue());
				}else{
					map.put("author", "");
				}
				
				list = fstElmnt.getElementsByTagName("publisher");
				element = (Element) list.item(0);
				list = element.getChildNodes();
				if(list.getLength()>0){
					map.put("publisher", ((Node)list.item(0)).getNodeValue());
				}else{
					map.put("publisher", "");
				}
				
				bookList.add(map);
			}
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
    
    private void showResult(){
    	String result = "";
    	for(int i=0; i<bookList.size(); i++){
    		 HashMap<String, String> map = bookList.get(i);
    		 result += map.get("name") + " (ISBN:" + map.get("isbn") +  ")" + "\n" + map.get("author") + "\n" + map.get("publisher") + "\n\n";
    	}
    	resultTv.setText(result);
    }
}